#climch_defs.py
#Functions used by coolplate control program cp_run.py
#ver.2017-11-27

import math, time
def cp_pid(tError,valuePrev,valueNow,targetPrev,targetNow,multP,multI,multD):
    "Generic PID algorithm"
    # tError is the accumulated error, held in the main program
    # calculate P term
    corrP = (targetNow - valueNow) * multP
    # Int term relies on error accumulated in main program
    corrI = tError * multI
    # Diff term uses prev and present values
    corrD = ((targetPrev - valuePrev) - (targetNow - valueNow)) * multD
    print ("Errors: Temperature=%0.2f P= %0.2f  I= %0.2f D= %0.2f " % (tError,corrP, corrI, corrD))
    return (corrP + corrI + corrD)
